package ac.essex.ooechs.facedetection.util.evaluation;

import ac.essex.gp.multiclass.PCM;
import ac.essex.gp.multiclass.BetterDRS;
import ac.essex.ooechs.imaging.commons.PixelLoader;
import ac.essex.ooechs.imaging.commons.HaarRegions;
import ac.essex.ooechs.imaging.commons.fast.HaarlikeFeatures;
import ac.essex.ooechs.imaging.commons.fast.IntegralImage;
import ac.essex.ooechs.facedetection.singlestage.nodes.FeatureUtils;

import java.io.File;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 07-Jul-2008
 * @version 1.0
 */
public class MouthDetector extends ObjectDetector {

    PCM pcm0 = new BetterDRS(-11.130250036433502,44.11748133735824,new int[]{1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0});

    public static void main(String[] args) throws Exception {
        MouthDetector d = new MouthDetector();
        d.test(new File("/home/ooechs/Data/me/smile/mouth/smiley/big/"));
        d.test(new File("/home/ooechs/Data/me/smile/mouth/smiley/"));
        d.test(new File("/home/ooechs/Data/me/smile/notmouth/"));
    }

    public double calculate(int x, int y, int windowWidth, int windowHeight, PixelLoader img) {

        HaarlikeFeatures image = img.getIntegralImage().getHaarlikeFeatures();
        HaarlikeFeatures varianceimage = img.getIntegralImage().getHaarlikeFeaturesVariance();

/*        double node1 = 0.41959473584773044 - 4.0;
        double node4 = varianceimage.getTwoRectangleFeature(x + FeatureUtils.getX(0.5027611092288884, windowWidth), y + FeatureUtils.getY(0.4232303940132129, windowHeight), FeatureUtils.getWidth(0.10711092656176738, windowWidth), FeatureUtils.getHeight(0.24049922409647795, windowHeight), HaarRegions.VERTICALLY_ADJACENT);
        return node1 - node4;*/

    double node2 = image.getTwoRectangleFeature(x + FeatureUtils.getX(0.4261715119988162, windowWidth), y + FeatureUtils.getY(0.18826944921991695, windowHeight), FeatureUtils.getWidth(0.6156365859020093, windowWidth), FeatureUtils.getHeight(0.0942826803905844, windowHeight), HaarRegions.VERTICALLY_ADJACENT);
    double node8 = Math.pow(0,0.0);
    double node7 = node8 - 4.0;
    double node1 = node7 != 0 ? node2 / node7 : 0;
    double node12 = varianceimage.getTwoRectangleFeature(x + FeatureUtils.getX(0.8932869217489134, windowWidth), y + FeatureUtils.getY(0.2630727618031694, windowHeight), FeatureUtils.getWidth(0.07245078829524632, windowWidth), FeatureUtils.getHeight(0.3442332215604682, windowHeight), HaarRegions.VERTICALLY_ADJACENT);
    return node1 - node12;

    }

}